//SETA43 4/07/2024
// seta43.duckdns.org
// seta43.blogspot.com /
// reproductor de wav desde MEMORIA ESP32
// Comando serie y oled
// wav 11kHz mono
// Arduino ESP32


#include "metro1.h"
long tamano=sizeof(rawData);

//___________OLED_________
#include "olex.h"
#include <Wire.h>

#define I2C_SDA 22 
#define I2C_SCL 23

 

char TITULO[]="-- ESP32 VOZ  --";


struct ESTA {
    char numero;
    char nombre[12];
    long ini;
    unsigned int tama;
};

struct ESTA estacion[]={ {0,"nada", 0,0},
        {1,"beep", 100,25960},
        {2,"proxima",28017,15983},
        {3,"cuatro", 44869,13409},
        {4,"rios", 59477,14443},
        {5,"iglesia", 74000,13153},
        {6,"bilbao" , 86636,12716},
        {7,"tribunal", 98670,12330},
        {8,"gran", 112244,15477},
        {9,"sol" , 128238,10824},
        {10,"Finsol",128238,10824} };

int nEstaciones=sizeof(estacion)/sizeof(*estacion);


//--------
unsigned char miCola[10];
char putCola(unsigned char n);
char getCola();


//--buffer entrada puerto serie
#define MAXENTRADA 15
char buffer[MAXENTRADA];
int contador=0;
char stringComplete = false;

uint32_t dire,tama;
byte fin=1;


//__________ENCODER_______seta43_____
#define PIN_IN1 32
#define PIN_IN2 33
#define EBOTON 5
int D_encoder=0;
char D_e1=0,D_e2=2;


char mandoRotary(void)  // 1-IZQ  2-DER  3-BOTON
{
  
   if (LOW==digitalRead(EBOTON))   { delay(300); return(3);}
   if (D_e1==0) 
      {  if(HIGH==digitalRead(PIN_IN1)) { D_e1=1; if(D_e2==3) { D_encoder++; return(2);} }   }
      else
      {  if(LOW==digitalRead(PIN_IN1))  { D_e1=0; if(D_e2==2) { D_encoder++; return(2);} }   }
      
  if (D_e2==2) 
      {  if(HIGH==digitalRead(PIN_IN2)) { D_e2=3; if(D_e1==1) { D_encoder--; return(1);} }   }
      else
      {  if(LOW==digitalRead(PIN_IN2))  { D_e2=2; if(D_e1==0) { D_encoder--; return(1);} }   }
  return(0);
}

//_________________________________________





hw_timer_t *timer = NULL;

void IRAM_ATTR timerInterrupcion() 
{
 if(dire>tama) { fin=1; dacWrite(25, 128);  } //
 if(fin==0) {  dacWrite(25, rawData[dire++]);  }
}



void setup() 
{
  Serial.begin(9600);
  while (!Serial);
  Serial.println(" "); Serial.println(TITULO);
  Serial.print("Tamaño=");  Serial.println(tamano); 
  Serial.print("N.Estaciones=");  Serial.println(nEstaciones);   

  Wire.begin(I2C_SDA, I2C_SCL);
  OleInit();
  xclearDisplay(); 
  ModeFont=0; xStringAT(0,0,TITULO);

  pinMode(EBOTON,INPUT_PULLUP);
  pinMode(PIN_IN1,INPUT_PULLUP);
  pinMode(PIN_IN2,INPUT_PULLUP);

  timer = timerBegin(1000000); // Timer 0, clock divider 80
  timerAttachInterrupt(timer, &timerInterrupcion); // Attach the interrupt handling function
  timerAlarm(timer, 90, true, 0); // ((1/11000)*1000000)
  playWav(100,19000); 

  for(int z=0;z<nEstaciones;z++) 
        { Serial.print(z);Serial.print(" "); Serial.println(estacion[z].nombre);  }
}



unsigned int tiempo;
char cambio=1;

void loop() 
{


  tiempo++;
  if(tiempo>30000)
      {
        tiempo=0;
         if(cambio!=0) 
            { 
              if(D_encoder<0) D_encoder=0;
              if(D_encoder>nEstaciones-1) D_encoder=nEstaciones-1; 
              displayPantalla();
              cambio=0;
            }
      }


  switch(mandoRotary())
      {
        case 1:
           cambio=1;
        break;
        case 2:
           cambio=1;
        break;
        case 3:
          sprintf(buffer,"%d",estacion[D_encoder].numero);
          Serial.println("BOTON cancion");
          stringComplete = true;
        break;  
      }
   



  
 //----Tratamiento entrada teclado ----
  while (Serial.available())
        {
          char inChar = (char)Serial.read(); 
          buffer[contador]=inChar;  
          if (inChar == '\n')
              {
                stringComplete = true;
                buffer[contador]=0;
              }       
          if(contador<MAXENTRADA)contador++;
        }
   if (stringComplete) 
        {     
          runFuniones();
          contador=0;
          stringComplete = false;   
        }
        
//-----Reproduce cola de audio -----
   if(fin==1) colaPlay();    
   
}




//------------------------------------------

void playWav(uint32_t di,uint32_t ta)
{
  dire=di;
  tama=dire+ta;
  if(tama>tamano)tama=tamano;
  fin=0;
}

//----------------------------------------------
char putCola(unsigned char n)
{
 int z;
    for(z=0;z<10;z++)   if(miCola[z]==0) {miCola[z]=n; break;}
    return(z);
}

char getCola()
{
 char c=miCola[0];
    for(int z=0;z<9;z++)  miCola[z]=miCola[z+1];
    miCola[9]=0;
 return(c);
}


void colaPlay()
{
  int n;
  n=getCola();
  if(n!=0)   playWav(estacion[n].ini,estacion[n].tama);  
}


//----------
void runFuniones(void)
{
  int numero,en;
      numero=atoi(buffer);       
      if(numero==0)
        {       
          Serial.println("Stop cancion");
          dire=0;
          fin=1;          
          goto salir0;
        }
      if(numero>nEstaciones) {Serial.println("ERROR N.estacion"); goto salir0;}
      for(en=0;en<nEstaciones;en++) 
        {
        if(estacion[en].numero==numero) 
          {
            D_encoder=en;
            Serial.print(en);Serial.print(" Estación="); Serial.println(estacion[en].nombre);
            displayPantalla();
            putCola(1); putCola(2);  putCola(en);
            goto salir0;
          }
        }
      Serial.println("aERROR ");
salir0:
 ;
}      



//--------------------------------------------------------------


void displayPantalla()
{
 char bufferOLE[16] = "";
   xclearDisplay(); 
   ModeFont=0; xStringAT(7,0,TITULO);
   sprintf(bufferOLE,"REG.=%03i ",D_encoder);  xStringAT(0,1,bufferOLE);
   ModeFont=2; 
   sprintf(bufferOLE,"COD.=%03i ",estacion[D_encoder].numero);  xStringAT(0,3,bufferOLE);
   ModeFont=1; 
   sprintf(bufferOLE,"%0s ",estacion[D_encoder].nombre);  xStringAT(0,6,bufferOLE);
}
